/* mkpic.c  --  reads resolution data files, writes mkdot input file "pic"  */

/* compile through all-mkpic.c */

#include "modules.h"

FILE *fpic;   /* for file pic */

int s,t;    /* s,t of a generator */

int hf_func(module *m) {
  s = m->sdeg; 
  printf("[C%d] ",s);
  fflush(stdout);
  return 1;
}

int gf_func(module *m, int n) {
  t = m->gens[n].deg;
  fprintf(fpic,"[%d,%d,%d]",s,t,n);
  return 1;
}   

int sf_func_hi(module *m, int n, stop *s) {
  int i,j;
  for (j=1;j<NALG;j++) if (0 != s->dat[j]) return 1;
  j = s->dat[0];
  if (!j || (0 != (j & (j-1)))) return 1; /* j is not a power of 2 */
  for (i=0;j>>=1;i++) ; 
  fprintf(fpic," h%d:%d",i,s->id);
  return 1;
}

int sf_func_h2i(module *m, int n, stop *s) {
  int i,j;
  if (0 != s->dat[0]) return 1;
  for (j=2;j<NALG;j++) if (0 != s->dat[j]) return 1;
  j = s->dat[1];
  if (!j || (0 != (j & (j-1)))) return 1; /* j is not a power of 2 */
  for (i=0;j>>=1;i++) ; 
  fprintf(fpic," h%d:%d",20+i,s->id);
  return 1;
}

int sf_func(module *m, int n, stop *s) {
  sf_func_hi(m,n,s);  /* look for hi multiplication */
  sf_func_h2i(m,n,s); /* look for Sq(0,1) and Sq(0,2) */
  return 1;
}

int ef_func(module *m, int n) {
  fprintf(fpic,"\n"); return 1;
}

int handle_C(int n) {
  module m; 
  copy_algebra(&(m.header.data.alg),&thealgebra);
  return parse_modulefile(n,&m,hf_func,gf_func,sf_func,ef_func,MOD_NOLOAD | MOD_NOCREATE);
}

void usage(void) {
  printf("usage:\n mkpic   (for the algebra A)\n mkpic n  (for A(n))\n");
  exit(1);
}

int main(int argc, char **argv) {

  int z=1,n;

  printf("mkpic.c -- writing mkdots input file pic\n");

  switch (argc) {
  case 1 : 
    set_algebra_Ainfty();
    break;
  case 2 :
    if (1 != sscanf(argv[1],"%d",&n)) usage();
    set_algebra_An(n);
    break;
  default :
    usage();
  }

  fpic = fopen("pic","wt");

  fprintf(fpic,"[0,0,0]\n"); /* fake (0,0) */

  while (handle_C(z++)) ;

  printf("\n");

  fclose(fpic);

  return 0;

}
