/* optimized multiplication routines */

#if !defined OPTMULT_DEF
#define OPTMULT_DEF

#include "bits.h"
#include "stoputils.h"
#include "modules.h"
#include "modseqno.h"
#include "linalg.h"
#include "error.h"

/* the following routine computes  s * diff                                 */
/* the result is added to the vectors dat[0],...,dat[n]  (dat[n+1] == NULL) */
/* dat[0],...,dat[n] are accessed through mi                                */
void optimized_multiply(stop *s, stoplist *diff, unit *(dat[]), 
								modinfo *mi, int deg);

/*
  For opt_make_matrix_same_sig:
     ms = source module,
     mt = target module,
     t  = the internal degree,
     bs = basis for ms,
     ts = basis for mt.

  The routine computes the fixes signature part of the matrix of the 
  differential.  This is stored in mat.    
*/
void opt_make_matrix_same_sig(
   module *ms, module *mt, int t, signature *sig,
   small_element *bs, small_element *bt, matrix *mat);

#endif
