/*  profile.h  */

#if !defined PROFILE_DEF
#define PROFILE_DEF

#include "stop.h"  /* needed for NALG */
#include "algebra.h"

typedef struct {
   int mask[NALG];   /* mask to filter out the signature bits */
   int shft[NALG];   /* 1 << shft[n] = mask[n]+1  ## get rid of this ## */
   int xdegrees[NALG];  
                     /*  xdegrees[n] = degrees[n] << shft[n]  */
   int numpts;       /* total number of bits in the signature */
   int numxi;        /* number of xi's that are restricted    */
   int datt[NALG * (NALG+1) / 2];   /*  t - coordinates       */
   int dats[NALG * (NALG+1) / 2];   /*  1 << ( s - coord. )   */
} profile;

extern profile theprofile; /* the profile that is set */

typedef stop signature;    /* signatures are implemented as stops */

void print_profile(profile *pro);  /* detailed information */
void fppf(FILE *fp, profile *p);   /* onscreen display     */
 
void set_empty_profile(void);

void set_max_profile_lower(int s, int t); 
void set_max_profile_upper(int s, int t); 

void first_signature(signature *sig);
int  next_signature(signature *sig);

#endif
