/* seqno.h   --   sequence number of stops */

#if !defined SEQNO_DEF
#define SEQNO_DEF

#include "stop.h"

/* NOTE: dim and seqno refer to the subalgebra defined by set_algebra_...() */

int dim(int n);  /* dimension of thealgebra in degree n */

/* the algorithm for seqno is adapted from Bob Bruners Ext package */

int seqno(stop *s); /* return sequence number of *s */
inline int seqno_with_degree(stop *s, short deg); 
/* seqno_with_degree is an interface to one of the following */
inline int opt_seqno_with_degree(stop *s, short dg); /* doesn't work with subalg. */
int safe_seqno_with_degree(stop *s, short dg);

void init_dimtab(int maxdegree);  /* has to be initialized by set_algebra_...() */

#endif
