/* stop.h   -   Steenrod operations  (basics + I/O) */

#if !defined STOP_DEF
#define STOP_DEF

#include <stdio.h>
#include "ints.h"

#define NALG 8      /* we're working over A(NALG) */
/* suffices up to dim 254.  currently NALG > 8 is **not** supported */

extern int MAXDEGREE;  /* only use stops of degree <= MAXDEGREE */

typedef struct { 
  #if NALG<9
  uint8  dat[NALG]; /* use 8 bits if restricted to degs < 255 */
  #else
  uint16 dat[NALG]; 
  #endif
  short int id;
} stop;  /* STeenrod OPeration */

extern int degrees[12];

void initialize_stops(void);

void clear_stop(stop *s);
void copy_stop(stop *s, stop *t);
int  degree_stop(stop *s, int *deglist);
int stops_are_equal(stop *a, stop *b);

void double_stop(stop *s);
int halve_stop(stop *s); /* returns 0 iff one entry is odd */
void invert_stop(stop *s); /* binary complement of each entry */

/* text based I/O */
void fprintf_stop(FILE *fp, stop *s);
int  fscanf_stop(FILE *fp, stop *s);
void print_stop(stop *s);

/* compressed I/O */
void write_enddiff(FILE *fp);
void write_stop(FILE *fp, stop *s);
int  read_stop(FILE *fp, stop *s);

#endif

